## git-annex 7.20190129

=== Makefile ===
all=git-annex git-annex-shell mans docs

# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
ifeq ($(BUILDER),stack)
GHC?=stack ghc --
else
GHC?=ghc
endif

PREFIX?=/usr
SHAREDIR?=share

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: $(all)

tmp/configure-stamp: Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" != stack ]; then \
		$(BUILDER) configure $(BUILDERCOMMONOPTIONS) --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	else \
		$(BUILDER) setup $(BUILDERCOMMONOPTIONS); \
	fi
	mkdir -p tmp
	touch tmp/configure-stamp

git-annex: tmp/configure-stamp
	$(BUILDER) build $(BUILDERCOMMONOPTIONS) $(BUILDEROPTIONS)
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(stack path $(BUILDERCOMMONOPTIONS) --dist-dir)/build/git-annex/git-annex git-annex; \
	else \
		ln -sf dist/build/git-annex/git-annex git-annex; \
	fi

git-annex-shell: git-annex
	ln -sf git-annex git-annex-shell

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 man/*.1 $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install-bins: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-remote-tor-annex

install-misc: build Build/InstallDesktopFile
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions
	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions/git-annex
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions
	@./git-annex --zsh-completion-script git-annex 2>/dev/null > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions/_git-annex || \
		echo "** zsh completions not installed; built with too old version of optparse-applicative"
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions
	@./git-annex --fish-completion-script git-annex 2>/dev/null > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions/git-annex.fish || \
		echo "** fish completions not installed; built with too old version of optparse-applicative"

install: install-bins install-docs install-misc

test: git-annex git-annex-shell
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

mans: Build/MakeMans
	./Build/MakeMans

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
docs: mans
	@if [ -n "`which ikiwiki`" ]; then \
		LC_ALL=C TZ=UTC ikiwiki doc html -v --wikiname git-annex \
			--plugin=goodstuff \
			--no-usedirs --disable-plugin=openid --plugin=sidebar \
			--plugin theme --set theme=actiontabs --set deterministic=1 \
			--disable-plugin=shortcut --disable-plugin=smiley \
			--plugin=comments --set comments_pagespec="*" \
			--exclude='ikiwiki/*' \
			--exclude='news/.*' --exclude='design/assistant/blog/*' \
			--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
			--exclude='users/*' --exclude='devblog/*' --exclude='thanks'; \
	else \
		echo "** ikiwiki not found, skipping building docs" >&2; \
	fi

clean:
	if [ "$(BUILDER)" != ./Setup ] && [ "$(BUILDER)" != cabal ]; then $(BUILDER) clean; fi
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig Build/Version \
		Setup Build/InstallDesktopFile \
		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
		Build/DistributionUpdate Build/BuildVersion Build/MakeMans \
		git-annex-shell git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/Standalone: Build/Standalone.hs tmp/configure-stamp
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/MakeMans: Build/MakeMans.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone: 
	$(MAKE) git-annex Build/Standalone Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	sed -i -e 's/^GIT_ANNEX_PACKAGE_INSTALL=/GIT_ANNEX_PACKAGE_INSTALL=$(GIT_ANNEX_PACKAGE_INSTALL)/' "$(LINUXSTANDALONE_DEST)/runshell"
	
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-remote-tor-annex"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/templates && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/magic"
	cp /usr/share/file/magic.mgc "$(LINUXSTANDALONE_DEST)/magic"
	cp /usr/share/i18n -a "$(LINUXSTANDALONE_DEST)"
	
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"

	sha1sum git-annex > "$(LINUXSTANDALONE_DEST)/buildid"
	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz

# Run this target to build git-annex-standalone*.deb
debianstandalone: dpkg-buildpackage-F
# Run this target to build git-annex-standalone*.dsc
debianstandalone-dsc: dpkg-buildpackage-S

prep-standalone:
	$(MAKE) undo-standalone
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
	debian/create-standalone-changelog

undo-standalone:
	test -e .git
	git checkout debian/changelog CHANGELOG
	quilt pop -a || true

commit-standalone:
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh

dpkg-buildpackage%: prep-standalone
	umask 022; dpkg-buildpackage -rfakeroot $*
	$(MAKE) undo-standalone

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp:
	$(MAKE) git-annex Build/Standalone Build/OSXMkLibs

	# Remove all RPATHs, both because this overloads the linker on
	# OSX Sierra, and to avoid the binary looking in someone's home
	# directory.
	if otool -l git-annex | grep -q "path "; then \
		eval install_name_tool $$(otool -l git-annex | grep "path " | sed 's/.*path /-delete_rpath /' | sed 's/ (.*//') git-annex; \
	fi

	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	ln -sf git-annex "$(OSXAPP_BASE)/git-remote-tor-annex"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"
	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(OSXAPP_BASE)"/templates && tar x)
	install -d "$(OSXAPP_BASE)/magic"
	if [ -e "$(OSX_MAGIC_FILE)" ]; then \
		cp "$(OSX_MAGIC_FILE)" "$(OSXAPP_BASE)/magic/magic.mgc"; \
	else \
		echo "** OSX_MAGIC_FILE not set; not including it" >&2; \
	fi

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_BASE)/.." SHAREDIR="" PREFIX=""

	./Build/OSXMkLibs $(OSXAPP_BASE)
	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg
	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg

# Bypass cabal, and only run the main ghc --make command for a
# faster development build.
fast: dist/cabalbuild
	@sh dist/cabalbuild
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/cabalbuild: dist/caballog
	grep 'ghc --make' dist/caballog | tail -n 1 > dist/cabalbuild
	
dist/caballog: git-annex.cabal
	$(BUILDER) configure -f"-Production" -O0 --enable-executable-dynamic
	$(BUILDER) build -v2 --ghc-options="-O0 -j" | tee dist/caballog

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports -g -XLambdaCase

distributionupdate:
	git pull
	cabal configure
	ghc -Wall -fno-warn-tabs --make Build/DistributionUpdate -XLambdaCase -XPackageImports
	./Build/DistributionUpdate

.PHONY: git-annex git-union-merge tags

=== debian/changelog ===
git-annex (7.20190129-3) unstable; urgency=medium

  * Resolve a race in test cleanup by making second attempt more forceful
    (Closes: #924800).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 31 Mar 2019 12:34:02 -0700

git-annex (7.20190129-2) unstable; urgency=medium

  * Cherry pick upstream commit a64fca92f6dfea086b7b9e65a2b83fb50fee1ecf.
    The most recent upload failed to build on mips; this should prevent
    that failure.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 03 Feb 2019 15:54:29 -0700

git-annex (7.20190129-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 29 Jan 2019 14:26:52 -0700

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 8.4.3),
	cabal-install,
	libghc-mtl-dev (>= 2.1.1),
	libghc-split-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-cryptonite-dev,
	libghc-memory-dev,
	libghc-attoparsec-dev,
	libghc-sandi-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-transformers-dev,
	libghc-exceptions-dev (>= 0.6),
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-aeson-dev,
	libghc-tagsoup-dev,
	libghc-unordered-containers-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-dbus-dev (>= 0.10.7) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-clientsession-dev            [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-tls-dev                 [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-dev                      [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-extra-dev                [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-dav-dev (>= 1.0),
	libghc-persistent-dev,
	libghc-persistent-template-dev,
	libghc-persistent-sqlite-dev,
	libghc-microlens-dev,
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-stm-chans-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-async-dev,
	libghc-monad-logger-dev,
	libghc-free-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev,
	libghc-tasty-dev (>= 0.7),
	libghc-tasty-hunit-dev,
	libghc-tasty-quickcheck-dev,
	libghc-tasty-rerun-dev,
	libghc-optparse-applicative-dev (>= 0.11.0),
	libghc-cabal-dev,
	libghc-torrent-dev,
	libghc-concurrent-output-dev,
	libghc-disk-free-space-dev,
	libghc-mountpoints-dev,
	libghc-magic-dev,
	libghc-socks-dev,
	libghc-vector-dev,
	lsof [linux-any],
	ikiwiki,
	libimage-magick-perl,
	git (>= 1:1.8.1),
	rsync,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
	gnupg,
	gpg-agent,
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Richard Hartmann <richih@debian.org>,
 Sean Whitton <spwhitton@spwhitton.name>,
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/haskell-team/git-annex.git/
Vcs-Browser: https://salsa.debian.org/haskell-team/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.1),
	netbase,
	rsync,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
Suggests:
	xdot,
	bup,
	adb,
	tor,
	magic-wormhole,
	tahoe-lafs,
	libnss-mdns,
	uftp,
	youtube-dl,
Breaks: datalad (<< 0.11.1~)
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.

=== debian/rules ===
#!/usr/bin/make -f

export BUILDER=./Setup

# -j1 is used for reproducible build
export BUILDEROPTIONS=-j1

# Reduce optimisation on armhf and armel to avoid running out of
# memory.  Passing -O1 to ghc causes it to pass -O2 to llc.  We can't
# simply use ghc's -optlc to pass -O2 to llc, because when we don't
# pass -O1 to ghc, it will pass an -O3 to llc, overriding our -optlc
# attempt.  See definition of runPhase in
# compiler/main/DriverPipeline.hs in ghc source
DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(filter armel,$(DEB_HOST_ARCH)))
export BUILDEROPTIONS:=$(BUILDEROPTIONS) --ghc-option=-O1
endif
ifneq (,$(filter armhf,$(DEB_HOST_ARCH)))
export BUILDEROPTIONS:=$(BUILDEROPTIONS) --ghc-option=-O1
endif

STANDALONE_BUILD=$(shell grep -qe '^Package: git-annex-standalone' debian/control \
                         && echo 1 || echo 0)

# Do use the changelog's version number, rather than making one up.
export RELEASE_BUILD=1

%:
	dh $@


# Standalone build logic/helpers
ifeq ($(STANDALONE_BUILD),1)

override_dh_auto_build:
	make linuxstandalone GIT_ANNEX_PACKAGE_INSTALL=1

override_dh_auto_install:
	make install-misc install-docs DESTDIR=debian/git-annex-standalone
	# bins are linked into place, as instructed in debian/install and debian/links

override_dh_fixperms:
	dh_fixperms -Xld-linux

# gdb can't do much with a haskell program, so avoid the debug package
override_dh_strip:
	dh_strip --no-ddebs

# Do not add "ldconfig" trigger since all libraries in the standalone build
# are private copies and the trigger activate-noawait trigger may not work
# on elderly distributions (e.g. squeeze)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

endif

## git-annex 7.20190912

=== Makefile ===
--- 
+++ 
@@ -11,6 +11,10 @@
 PREFIX?=/usr
 SHAREDIR?=share
 
+# On Debian systems, zsh does not look here, and you will have to override
+# this to /usr/share/zsh/vendor-completions
+ZSH_COMPLETIONS_PATH?=$(PREFIX)/$(SHAREDIR)/zsh/site-functions
+
 # Am I typing :make in vim? Do a fast build.
 ifdef VIM
 all=fast
@@ -18,8 +22,18 @@
 
 build: $(all)
 
+# install system-wide
+# Set PREFIX and DESTDIR to configure where it is installed
+install: install-bins install-docs install-completions install-desktop
+
+# installs into your home directory
+install-home:
+	$(MAKE) install-bins PREFIX=$(HOME)/.local
+	$(MAKE) install-mans PREFIX=$(HOME)/.local
+	$(MAKE) install-desktop PREFIX=$(HOME)/.local USERDIR=1
+
 tmp/configure-stamp: Build/TestConfig.hs Build/Configure.hs
-	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
+	if [ "$(BUILDER)" = ./Setup ]; then $(GHC) --make Setup; fi
 	if [ "$(BUILDER)" != stack ]; then \
 		$(BUILDER) configure $(BUILDERCOMMONOPTIONS) --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
 	else \
@@ -61,18 +75,18 @@
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-remote-tor-annex
 
-install-misc: build Build/InstallDesktopFile
+install-desktop: build Build/InstallDesktopFile
 	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
+
+install-completions: build
 	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions
 	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions/git-annex
-	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions
-	@./git-annex --zsh-completion-script git-annex 2>/dev/null > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/zsh/vendor-completions/_git-annex || \
-		echo "** zsh completions not installed; built with too old version of optparse-applicative"
+	install -d $(DESTDIR)$(ZSH_COMPLETIONS_PATH)
+	./git-annex --zsh-completion-script git-annex 2>/dev/null \
+		> $(DESTDIR)$(ZSH_COMPLETIONS_PATH)/_git-annex
 	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions
-	@./git-annex --fish-completion-script git-annex 2>/dev/null > $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions/git-annex.fish || \
-		echo "** fish completions not installed; built with too old version of optparse-applicative"
-
-install: install-bins install-docs install-misc
+	./git-annex --fish-completion-script git-annex 2>/dev/null \
+		> $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions/git-annex.fish
 
 test: git-annex git-annex-shell
 	./git-annex test
@@ -82,7 +96,7 @@
 
 # hothasktags chokes on some template haskell etc, so ignore errors
 tags:
-	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags
+	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -XLambdaCase -XPackageImports -c --cpp -c -traditional -c --include=dist/build/git-annex/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags
 
 mans: Build/MakeMans
 	./Build/MakeMans
@@ -120,6 +134,8 @@
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/Standalone: Build/Standalone.hs tmp/configure-stamp
 	$(GHC) --make $@ -Wall -fno-warn-tabs
+Build/BuildVersion: Build/BuildVersion.hs
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/OSXMkLibs: Build/OSXMkLibs.hs
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/LinuxMkLibs: Build/LinuxMkLibs.hs
@@ -163,9 +179,9 @@
 	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
 	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz
 
-# Run this target to build git-annex-standalone*.deb
+# Run this target to build git-annex-standalone.deb
 debianstandalone: dpkg-buildpackage-F
-# Run this target to build git-annex-standalone*.dsc
+# Run this target to build git-annex-standalone.dsc
 debianstandalone-dsc: dpkg-buildpackage-S
 
 prep-standalone:
@@ -188,7 +204,7 @@
 OSXAPP_DEST=tmp/build-dmg/git-annex.app
 OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
 osxapp:
-	$(MAKE) git-annex Build/Standalone Build/OSXMkLibs
+	$(MAKE) git-annex Build/Standalone Build/OSXMkLibs Build/BuildVersion
 
 	# Remove all RPATHs, both because this overloads the linker on
 	# OSX Sierra, and to avoid the binary looking in someone's home
@@ -200,6 +216,9 @@
 	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
 	install -d tmp/build-dmg
 	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"
+	sed -e 's/GIT_ANNEX_VERSION/$(shell Build/BuildVersion)/' \
+		< standalone/osx/Info.plist.template \
+		> "$(OSXAPP_DEST)"/Contents/Info.plist
 
 	install -d "$(OSXAPP_BASE)"
 	cp git-annex "$(OSXAPP_BASE)"

=== debian/changelog ===
git-annex (7.20190912-1) unstable; urgency=medium

  * New upstream release.
    - Update build-dep bounds.
  * Fix COPYRIGHT for Annex/DirHashes.hs.
    File header indicates GPL, not AGPL.
  * Try dropping patch introduced in 7.20181211-2 upload now that v7 repos
    are the default.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 28 Sep 2019 10:53:03 -0700

=== debian/control ===
--- 
+++ 
@@ -10,15 +10,16 @@
 	libghc-data-default-dev,
 	libghc-hslogger-dev,
 	libghc-pcre-light-dev,
-	libghc-cryptonite-dev,
+	libghc-cryptonite-dev (>= 0.23),
 	libghc-memory-dev,
+	libghc-deepseq-dev,
 	libghc-attoparsec-dev,
 	libghc-sandi-dev,
 	libghc-utf8-string-dev,
-	libghc-aws-dev (>= 0.9.2-2~),
+	libghc-aws-dev (>= 0.20),
 	libghc-conduit-dev,
 	libghc-resourcet-dev,
-	libghc-quickcheck2-dev,
+	libghc-quickcheck2-dev (>= 2.10.0),
 	libghc-monad-control-dev (>= 0.3),
 	libghc-transformers-dev,
 	libghc-exceptions-dev (>= 0.6),
@@ -29,13 +30,13 @@
 	libghc-tagsoup-dev,
 	libghc-unordered-containers-dev,
 	libghc-ifelse-dev,
-	libghc-bloomfilter-dev,
+	libghc-bloomfilter-dev (>= 2.0.0),
 	libghc-edit-distance-dev,
-	libghc-hinotify-dev [linux-any],
+	libghc-hinotify-dev (>= 0.3.10) [linux-any],
 	libghc-dbus-dev (>= 0.10.7) [linux-any],
 	libghc-fdo-notify-dev (>= 0.3) [linux-any],
 	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
-	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
+	libghc-yesod-core-dev (>= 1.6.0)    [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
@@ -45,16 +46,16 @@
 	libghc-wai-dev                      [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-wai-extra-dev                [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
 	libghc-dav-dev (>= 1.0),
-	libghc-persistent-dev,
+	libghc-persistent-dev (>= 2.8.1),
 	libghc-persistent-template-dev,
-	libghc-persistent-sqlite-dev,
+	libghc-persistent-sqlite-dev (>= 2.8.1),
 	libghc-microlens-dev,
 	libghc-securemem-dev,
 	libghc-byteable-dev,
 	libghc-stm-chans-dev,
 	libghc-case-insensitive-dev,
 	libghc-http-types-dev,
-	libghc-http-conduit-dev,
+	libghc-http-conduit-dev (>= 2.3.0),
 	libghc-blaze-builder-dev,
 	libghc-crypto-api-dev,
 	libghc-network-multicast-dev,
@@ -63,16 +64,16 @@
 	libghc-async-dev,
 	libghc-monad-logger-dev,
 	libghc-free-dev,
-	libghc-feed-dev (>= 0.3.9.2),
+	libghc-feed-dev (>= 1.0.0),
 	libghc-regex-tdfa-dev,
 	libghc-tasty-dev (>= 0.7),
 	libghc-tasty-hunit-dev,
 	libghc-tasty-quickcheck-dev,
 	libghc-tasty-rerun-dev,
-	libghc-optparse-applicative-dev (>= 0.11.0),
+	libghc-optparse-applicative-dev (>= 0.14.1),
 	libghc-cabal-dev,
 	libghc-torrent-dev,
-	libghc-concurrent-output-dev,
+	libghc-concurrent-output-dev (>= 1.10),
 	libghc-disk-free-space-dev,
 	libghc-mountpoints-dev,
 	libghc-magic-dev,
@@ -81,7 +82,7 @@
 	lsof [linux-any],
 	ikiwiki,
 	libimage-magick-perl,
-	git (>= 1:1.8.1),
+	git (>= 1:2.1),
 	rsync,
 	curl,
 	openssh-client,

## git-annex 7.20191017

=== Makefile ===
--- 
+++ 
@@ -162,10 +162,6 @@
 
 	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
 	
-	install -d "$(LINUXSTANDALONE_DEST)/git-core"
-	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
-	install -d "$(LINUXSTANDALONE_DEST)/templates"
-	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/templates && tar x)
 	install -d "$(LINUXSTANDALONE_DEST)/magic"
 	cp /usr/share/file/magic.mgc "$(LINUXSTANDALONE_DEST)/magic"
 	cp /usr/share/i18n -a "$(LINUXSTANDALONE_DEST)"
@@ -231,9 +227,6 @@
 
 	./Build/Standalone $(OSXAPP_BASE)
 
-	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
-	install -d "$(OSXAPP_BASE)/templates"
-	(cd "$(shell git --man-path)"/../git-core/templates && tar c .) | (cd "$(OSXAPP_BASE)"/templates && tar x)
 	install -d "$(OSXAPP_BASE)/magic"
 	if [ -e "$(OSX_MAGIC_FILE)" ]; then \
 		cp "$(OSX_MAGIC_FILE)" "$(OSXAPP_BASE)/magic/magic.mgc"; \
@@ -248,8 +241,19 @@
 	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
 	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
 	rm -f tmp/git-annex.dmg
-	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
-		-volname git-annex -o tmp/git-annex.dmg
+	
+	# hdiutil sometimes fails with "resource busy", so try a few times
+	ok=0; for x in 1 2 3 4 5; do \
+		if [ $$ok = 0 ]; then \
+			if hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
+				-volname git-annex -o tmp/git-annex.dmg; \
+			then \
+				ok=1; \
+			else \
+				sleep 60; \
+			fi \
+		fi \
+	done
 
 # Bypass cabal, and only run the main ghc --make command for a
 # faster development build.

## git-annex 7.20191024

=== debian/changelog ===
git-annex (7.20191024-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 28 Oct 2019 22:28:45 -0700

git-annex (7.20191017-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 18 Oct 2019 08:50:20 -0700

git-annex (7.20191009-1) unstable; urgency=medium

  * New upstream release.
  * Add libghc-unliftio-core-dev build-dep.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 12 Oct 2019 14:59:58 -0700

=== debian/control ===
--- 
+++ 
@@ -79,6 +79,7 @@
 	libghc-magic-dev,
 	libghc-socks-dev,
 	libghc-vector-dev,
+        libghc-unliftio-core-dev,
 	lsof [linux-any],
 	ikiwiki,
 	libimage-magick-perl,

## git-annex 7.20191114

=== debian/changelog ===
git-annex (7.20191114-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 18 Nov 2019 16:04:46 -0700

## git-annex 7.20191230

=== Makefile ===
--- 
+++ 
@@ -253,7 +253,7 @@
 				sleep 60; \
 			fi \
 		fi \
-	done
+	done; if [ $$ok = 0 ]; then exit 1; fi
 
 # Bypass cabal, and only run the main ghc --make command for a
 # faster development build.

=== debian/changelog ===
git-annex (7.20191230-1build4) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jan 2020 20:50:32 +0100

git-annex (7.20191230-1) unstable; urgency=medium

  * New upstream release.
  * Add libghc-filepath-bytestring-dev build-dep.
  * Require git >=1:2.22.
  * d/copyright updates:
    - Add stanza for Utility/Attoparsec.hs
    - Drop stanza for Annex/DirHashes.hs
      The file header was mistakenly updated to say "GPL" in upstream
      commit f845636e30728c5c45c0559e7059aa51c188bfd6.
    - Merge `License: GPL-2` stanza into `License: Expat or GPL-2` stanza.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 02 Jan 2020 20:13:14 +0000

## git-annex 7.20200219

=== Makefile ===
--- 
+++ 
@@ -84,9 +84,9 @@
 	install -d $(DESTDIR)$(ZSH_COMPLETIONS_PATH)
 	./git-annex --zsh-completion-script git-annex 2>/dev/null \
 		> $(DESTDIR)$(ZSH_COMPLETIONS_PATH)/_git-annex
-	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions
+	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/vendor_completions.d
 	./git-annex --fish-completion-script git-annex 2>/dev/null \
-		> $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/completions/git-annex.fish
+		> $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/vendor_completions.d/git-annex.fish
 
 test: git-annex git-annex-shell
 	./git-annex test

=== debian/changelog ===
git-annex (7.20200219-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 21 Feb 2020 07:26:47 -0700

## git-annex 8.20200226

=== Makefile ===
--- 
+++ 
@@ -44,10 +44,14 @@
 
 git-annex: tmp/configure-stamp
 	$(BUILDER) build $(BUILDERCOMMONOPTIONS) $(BUILDEROPTIONS)
-	if [ "$(BUILDER)" = stack ]; then \
+	@if [ "$(BUILDER)" = stack ]; then \
 		ln -sf $$(stack path $(BUILDERCOMMONOPTIONS) --dist-dir)/build/git-annex/git-annex git-annex; \
 	else \
-		ln -sf dist/build/git-annex/git-annex git-annex; \
+		if [ -d dist-newstyle ]; then \
+			ln -sf $$(find dist-newstyle/ -executable -type f |grep 'git-annex$$') git-annex; \
+		else \
+			ln -sf dist/build/git-annex/git-annex git-annex; \
+		fi; \
 	fi
 
 git-annex-shell: git-annex

=== debian/changelog ===
git-annex (8.20200226-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 26 Feb 2020 22:03:39 -0700

=== debian/control ===
--- 
+++ 
@@ -80,10 +80,11 @@
 	libghc-socks-dev,
 	libghc-vector-dev,
         libghc-unliftio-core-dev,
+	libghc-filepath-bytestring-dev,
 	lsof [linux-any],
 	ikiwiki,
 	libimage-magick-perl,
-	git (>= 1:2.1),
+	git (>= 1:2.22),
 	rsync,
 	curl,
 	openssh-client,
@@ -104,7 +105,7 @@
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends},
-	git (>= 1:1.8.1),
+	git (>= 1:2.22),
 	netbase,
 	rsync,
 	curl,

## git-annex 8.20200330

=== debian/changelog ===
git-annex (8.20200330-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 19 Apr 2020 16:54:51 -0700

git-annex (8.20200330-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 30 Mar 2020 20:26:25 -0700

git-annex (8.20200309-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 09 Mar 2020 15:12:22 -0700

git-annex (8.20200226-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 28 Feb 2020 15:10:29 -0700

git-annex (7.20191114-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 29 Nov 2019 10:13:37 -0700

git-annex (7.20191024-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 31 Oct 2019 16:22:18 -0700

git-annex (7.20191017-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 19 Oct 2019 09:55:23 -0700

=== debian/control ===
--- 
+++ 
@@ -127,7 +127,7 @@
 	libnss-mdns,
 	uftp,
 	youtube-dl,
-Breaks: datalad (<< 0.11.1~)
+Breaks: datalad (<< 0.12.3~)
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file
  contents into git. While that may seem paradoxical, it is useful when

## git-annex 8.20200908

=== Makefile ===
all=git-annex git-annex-shell mans docs

# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
ifeq ($(BUILDER),stack)
GHC?=stack ghc --
else
GHC?=ghc
endif

PREFIX?=/usr
SHAREDIR?=share

# On Debian systems, zsh does not look here, and you will have to override
# this to /usr/share/zsh/vendor-completions
ZSH_COMPLETIONS_PATH?=$(PREFIX)/$(SHAREDIR)/zsh/site-functions

# Am I typing :make in vim? Do a dev build.
ifdef VIM
all=dev
endif

build: $(all)

# install system-wide
# Set PREFIX and DESTDIR to configure where it is installed
install: install-bins install-docs install-completions install-desktop

# installs into your home directory
install-home:
	$(MAKE) install-bins PREFIX=$(HOME)/.local
	$(MAKE) install-mans PREFIX=$(HOME)/.local
	$(MAKE) install-desktop PREFIX=$(HOME)/.local USERDIR=1

tmp/configure-stamp: Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then $(GHC) --make Setup; fi
	if [ "$(BUILDER)" != stack ]; then \
		$(BUILDER) configure $(BUILDERCOMMONOPTIONS) --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	else \
		$(BUILDER) setup $(BUILDERCOMMONOPTIONS); \
	fi
	mkdir -p tmp
	touch tmp/configure-stamp

# Non-optimised build for development.
#
# This leaves cabal.project.local configured for a dev build,
# so just running make will continue to do dev builds.
dev:
	$(BUILDER) configure -f"-Production" -O0 --enable-executable-dynamic
	mkdir -p tmp
	touch tmp/configure-stamp
	$(MAKE) git-annex

git-annex: tmp/configure-stamp
	$(BUILDER) build $(BUILDERCOMMONOPTIONS) $(BUILDEROPTIONS)
	@if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(stack path $(BUILDERCOMMONOPTIONS) --dist-dir)/build/git-annex/git-annex git-annex; \
	else \
		if [ -d dist-newstyle ]; then \
			ln -sf $$(cabal exec -- sh -c 'command -v git-annex') git-annex; \
		else \
			ln -sf dist/build/git-annex/git-annex git-annex; \
		fi; \
	fi

git-annex-shell: git-annex
	ln -sf git-annex git-annex-shell

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 man/*.1 $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install-bins: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-remote-tor-annex

install-desktop: build Build/InstallDesktopFile
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true

install-completions: build
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions
	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/$(SHAREDIR)/bash-completion/completions/git-annex
	install -d $(DESTDIR)$(ZSH_COMPLETIONS_PATH)
	./git-annex --zsh-completion-script git-annex 2>/dev/null \
		> $(DESTDIR)$(ZSH_COMPLETIONS_PATH)/_git-annex
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/vendor_completions.d
	./git-annex --fish-completion-script git-annex 2>/dev/null \
		> $(DESTDIR)$(PREFIX)/$(SHAREDIR)/fish/vendor_completions.d/git-annex.fish

test: git-annex git-annex-shell
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# tags file for vim
tags:
	@$(MAKE) --quiet hothasktags HOTHASKTAGS_OPT= TAGFILE=tags

# TAGS file for emacs
TAGS:
	@$(MAKE) --quiet hothasktags HOTHASKTAGS_OPT=-e TAGFILE=TAGS

# https://github.com/luqui/hothasktags/issues/18
HOTHASKTAGS_ARGS=-XLambdaCase -XPackageImports --cpp

hothasktags:
	@if ! cabal exec hothasktags -- $(HOTHASKTAGS_OPT) $(HOTHASKTAGS_ARGS) \
		$$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v dist/ | grep -v /doc/ | egrep '\.hs$$') 2>/dev/null \
			| sort > $(TAGFILE); then \
		echo "** hothasktags failed"; \
	fi

mans: Build/MakeMans
	./Build/MakeMans

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
docs: mans
	@if [ -n "`which ikiwiki`" ]; then \
		LC_ALL=C TZ=UTC ikiwiki doc html -v --wikiname git-annex \
			--plugin=goodstuff \
			--no-usedirs --disable-plugin=openid --plugin=sidebar \
			--plugin theme --set theme=actiontabs --set deterministic=1 \
			--disable-plugin=shortcut --disable-plugin=smiley \
			--plugin=comments --set comments_pagespec="*" \
			--exclude='ikiwiki/*' \
			--exclude='news/.*' --exclude='design/assistant/blog/*' \
			--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
			--exclude='users/*' --exclude='devblog/*' --exclude='thanks'; \
	else \
		echo "** ikiwiki not found, skipping building docs" >&2; \
	fi

clean:
	if [ "$(BUILDER)" != ./Setup ] && [ "$(BUILDER)" != cabal ]; then $(BUILDER) clean; fi
	rm -rf tmp dist dist-newstyle git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags TAGS Build/SysConfig Build/Version \
		Setup Build/InstallDesktopFile Build/Standalone \
		Build/DistributionUpdate Build/BuildVersion Build/MakeMans \
		git-annex-shell git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/Standalone: Build/Standalone.hs tmp/configure-stamp
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/BuildVersion: Build/BuildVersion.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/MakeMans: Build/MakeMans.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone:
	$(MAKE) git-annex Build/Standalone
	./Build/Standalone "$(LINUXSTANDALONE_DEST)" "$(LINUXSTANDALONE_DEST)"

	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	sha1sum git-annex > "$(LINUXSTANDALONE_DEST)/buildid"
	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz

# Run this target to build git-annex-standalone.deb
debianstandalone: dpkg-buildpackage-F
# Run this target to build git-annex-standalone.dsc
debianstandalone-dsc: dpkg-buildpackage-S

prep-standalone:
	$(MAKE) undo-standalone
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
	debian/create-standalone-changelog

undo-standalone:
	test -e .git
	git checkout debian/changelog CHANGELOG
	quilt pop -a || true

commit-standalone:
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh

dpkg-buildpackage%: prep-standalone
	umask 022; dpkg-buildpackage -rfakeroot $*
	$(MAKE) undo-standalone

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_TOP=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp:
	$(MAKE) git-annex
	# Remove all RPATHs, both because this overloads the linker on
	# OSX Sierra, and to avoid the binary looking in someone's home
	# directory.
	if otool -l git-annex | grep -q "path "; then \
		eval install_name_tool $$(otool -l git-annex | grep "path " | sed 's/.*path /-delete_rpath /' | sed 's/ (.*//') git-annex; \
	fi

	$(MAKE) Build/Standalone
	./Build/Standalone $(OSXAPP_TOP) $(OSXAPP_DEST)

	gzcat standalone/licences.gz > $(OSXAPP_TOP)/LICENSE
	cp $(OSXAPP_TOP)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_TOP)/.." SHAREDIR="" PREFIX=""

	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg

	# hdiutil sometimes fails with "resource busy", so try a few times
	ok=0; for x in 1 2 3 4 5; do \
		if [ $$ok = 0 ]; then \
			if hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
				-volname git-annex -o tmp/git-annex.dmg; \
			then \
				ok=1; \
			else \
				sleep 60; \
			fi \
		fi \
	done; if [ $$ok = 0 ]; then exit 1; fi

distributionupdate:
	git pull
	cabal configure
	ghc -Wall -fno-warn-tabs --make Build/DistributionUpdate -XLambdaCase -XPackageImports
	./Build/DistributionUpdate

.PHONY: git-annex git-union-merge tags TAGS

=== debian/changelog ===
git-annex (8.20200908-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Fix debian/copyright to be a copy, not a symlink, as otherwise this is
      an auto-reject.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 25 Oct 2020 14:39:56 -0700

git-annex (8.20200908-1) unstable; urgency=medium

  * New upstream release (Closes: #969908).
  * Add deps on http-client-restricted and git-lfs Haskell libs.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 13 Sep 2020 20:27:50 -0700

git-annex (8.20200330-1ubuntu1) groovy; urgency=medium

  * No-change rebuild against libffi8ubuntu1.
  * Fix debian/copyright to be a copy, not a symlink, as otherwise this is
    an auto-reject.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 29 Aug 2020 01:56:00 +0000

=== debian/control ===
--- 
+++ 
@@ -81,6 +81,8 @@
 	libghc-vector-dev,
         libghc-unliftio-core-dev,
 	libghc-filepath-bytestring-dev,
+	libghc-http-client-restricted-dev,
+	libghc-git-lfs-dev,
 	lsof [linux-any],
 	ikiwiki,
 	libimage-magick-perl,
@@ -91,7 +93,8 @@
 	git-remote-gcrypt (>= 0.20130908-6),
 	gnupg,
 	gpg-agent,
-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders:
  Richard Hartmann <richih@debian.org>,
  Sean Whitton <spwhitton@spwhitton.name>,

## git-annex 8.20201103

=== debian/changelog ===
git-annex (8.20201103-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix debian/copyright to be a copy, not a symlink, as otherwise this is
      an auto-reject.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 30 Nov 2020 13:04:48 -0800

git-annex (8.20201103-1) unstable; urgency=medium

  * Drop spurious slash from the end of Vcs-Git.
  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 07 Nov 2020 13:08:22 -0700

git-annex (8.20201007-1) unstable; urgency=medium

  * New upstream release.
  * Add build-dep on libghc-criterion-dev.
  * Raise debhelper compat to 13, and move debian/compat->debian/control.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 26 Oct 2020 15:29:31 -0700

## git-annex 8.20201127

=== debian/changelog ===
git-annex (8.20201127-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix debian/copyright to be a copy, not a symlink, as otherwise this is
      an auto-reject.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 06 Jan 2021 19:35:43 -0800

git-annex (8.20201127-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 27 Dec 2020 15:09:49 -0700

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,8 @@
 # Do use the changelog's version number, rather than making one up.
 export RELEASE_BUILD=1
 
+export ZSH_COMPLETIONS_PATH=/usr/share/zsh/vendor-completions
+
 %:
 	dh $@
 
@@ -36,7 +38,8 @@
 	make linuxstandalone GIT_ANNEX_PACKAGE_INSTALL=1
 
 override_dh_auto_install:
-	make install-misc install-docs DESTDIR=debian/git-annex-standalone
+	make install-desktop install-docs install-completions \
+		DESTDIR=debian/git-annex-standalone
 	# bins are linked into place, as instructed in debian/install and debian/links
 
 override_dh_fixperms:
